/**
 * Created by huanggang on 2017/4/27.
 */
import Actions from '../../../lib/Actions'
import Home2 from '../home2.vue'
import Divider from '../divider.vue'
import Image from '../Image.vue'
import EmptyBlock from '../empty_bock.vue'
import  Webview from '../webview.vue'
import Swiper from '../swiper_list.vue'
import {base64} from 'vux'
import GoodsList from '../goods_list.vue'
import GoodsItem from '../goods_item.vue'
import HorizonGoodsItem from '../horizongoods_item.vue'
import HorizonGoodsList from '../horizongoods_list.vue'
import GridList from '../GridList.vue'
import Video from '../video.vue'
import Homewords from '../hot_search.vue'
import HomeGrid from '../HomeGrid.vue'
import Brand from '../brand.vue'
import FCode from '../fcode.vue'
import GoodsTop from '../goods_top.vue'
import UgcList from '../ugc_list.vue'
class BlockUtil {
    static createBlockComp(createElement, special, proxy, pos) {
        let comp;
        let params = {
            props: {
                special: special,
                proxy: proxy,
                pos:pos
            },
        };
        try {
            switch (special['item_type']) {
                case "adv_list" :
                    comp = createElement(Swiper, params);
                    break;
                case "divider" :
                    comp = createElement(Divider, params);
                    break;
                case "home2" :
                    comp = createElement(Home2, params);
                    break;
                case "home1" :
                case 'home5':
                case 'home_type':
                    comp = createElement(EmptyBlock, params);
                    break;
                case 'home_goods' :
                    comp = createElement(GoodsList, params);
                    break;
                case "horizon":
                case 'horizon_goods' :
                    comp = createElement(HorizonGoodsList, params);
                    break;
                case 'home3' :
                    comp = createElement(GridList, params);
                    break;
                case 'homewords' :
                    comp = createElement(Homewords, params);
                    break;
                case "home_grid":
                    comp = createElement(HomeGrid, params);
                    break;
                default:
                    comp = createElement('div', '类型：'+special['item_type']+'找不到');
                    break;
            }
        } catch (e) {
            comp = createElement('div', '创建失败：'+e);
        }
        return comp;
    }

    static createBlockItemComp(createElement, scale, item, proxy, attrs) {
        let comp;
        let params = {
            props: {
                item: item,
                proxy: proxy,
                scale: scale,
                attrs: attrs
            }
        };
        let showType = "";
        if (item.hasOwnProperty("show_type")) {
            showType = item.show_type;
        } else {
            showType = item.type;
        }
        try {
            switch (showType) {
                case "image" :
                    comp = createElement(Image, params);
                    break;
                case "webview" :
                    comp = createElement(Webview, params);
                    break;
                case "goods" :
                    comp = createElement(GoodsItem, params);
                    break;
                case "goods_simple" :
                    comp = createElement(HorizonGoodsItem, params);
                    break;
                case 'video' :
                    comp = createElement(Video, params);
                    break;
                case "brand":
                    comp = createElement(Brand, params);
                    break;
                case "fcode":
                    comp = createElement(FCode, params);
                    break;
                case "goods_top":
                    comp = createElement(GoodsTop,params);
                    break;
                case "ugc":
                    comp = createElement(UgcList,params);
                    console.log(params);
                    break;
                default:
                    comp = createElement('div', '类型：'+special['item_type']+'找不到');
                    break;
            }
        } catch (e) {
            comp = createElement('div', '创建失败：'+e);
        }
        return comp;
    }

    static blockClick(router, item, proxy, is_return) {
        let action_type = item.type;
        let action_data = item.data;
        console.log(item);
        console.log(action_data);
        console.log(action_type);

        return false;


        if(item.data == '') {
            return "";
        }
        let title = item.title ? item.title : "熊猫美妆";

        if (!item || !proxy || !action_type || !action_data) {
            return;
        }

        let special_id = proxy.getTag("SPECIAL_ID");
        let hot_id = proxy.getTag("HOT_ID");
        let brand_id = proxy.getTag("BRAND_ID");
        let keyword = proxy.getTag("WORDS");
        let path;
        switch (action_type) {
            case 'url':
                path = Actions.getWebViewPath(title, action_data);
                if (is_return) {
                    return this.getBlockUrl(path);
                } else {
                    console.log(path.query.url);
                    path.query.url = base64.encode( path.query.url);
                    console.log(path);
                    router.push(path);
                }
                break;
            case 'goods':
                path = Actions.getGoodsDetailPath(action_data);
                if (is_return) {
                    return this.getBlockUrl(path);
                } else {
                    router.push(path);
                }
                break;
            case 'special':
                path = Actions.getSpecialListPath(action_data, title);
                if (is_return) {
                    return this.getBlockUrl(path);
                } else {
                    router.push(path);
                }
                break;
            case 'keyword':
                path = Actions.getFilterBlockListPath(action_data, special_id, hot_id, brand_id, action_data);
                if (is_return) {
                    return this.getBlockUrl(path);
                } else {
                    router.push(path);
                }
                break;
            case 'brand':
                path = Actions.getFilterBlockListPath(title, special_id, hot_id, action_data, keyword);
                if (is_return) {
                    return this.getBlockUrl(path);
                } else {
                    router.push(path);
                }
                break;
            case 'category':
                path = Actions.getFilterBlockListPath(title, special_id, action_data, brand_id, keyword);
                if (is_return) {
                    return this.getBlockUrl(path);
                } else {
                    router.push(path);
                }
                break;
            case 'appjump':
                path = Actions.getSchemaPathPath(action_data);
                if (is_return) {
                    return this.getBlockUrl(path);
                } else {
                    router.push(path);
                }
                break;
        }

        return "";
    }

    static getBlockUrl(schema) {
        if (typeof(schema.path) == "undefined") return;
        let ret = schema.path;
        if (schema.query) {
            let g = 0;
            for (let i in schema.query) {
                if (g === 0) {
                    let value = schema.query[i];
                    if (i == 'url') {
                        value = base64.encode(value)
                    }
                    ret += "?" + i + "=" + value;
                } else {
                    let value = schema.query[i];
                    if (i == 'url') {
                        value = base64.encode(value)
                    }
                    ret += "&" + i + "=" + value;
                }
                g++;
            }
        }
        return ret;
    }


}
export default BlockUtil





































