class Proxy {

    constructor() {
        this.cartList = [];
        this.bundlingList = [];
        this.summeryList = [];
        this.groupBuyList = [];
        this.fcodeList = [];
        this.specialList = [];
        this.data = {};
        this.tabs = [];
        this.limitTime = [];
        this.tags = new Map();
    }

    addData(json, is_init) {
        this.specialList = this.specialList.concat(json.special_list);
        this.cartList = this.cartList.concat(json.cart_list);
        this.bundlingList = this.bundlingList.concat(json.bundling);
        this.summeryList = this.summeryList.concat(json.summary);
        this.groupBuyList = this.groupBuyList.concat(json.groupbuy);
        this.fcodeList = this.fcodeList.concat(json.fcodes);
        this.tabs = json.tabs;
        this.limitTime = json.limitime;
    }

    restoreData(text) {
        this.clearData();
        let json = JSON.parse(text);
        this.specialList = this.specialList.concat(json.specialList);
        this.cartList = this.cartList.concat(json.cartList);
        this.bundlingList = this.bundlingList.concat(json.bundlingList);
        this.summeryList = this.summeryList.concat(json.summeryList);
        this.groupBuyList = this.groupBuyList.concat(json.groupBuyList);
        this.fcodeList = this.fcodeList.concat(json.fcodeList);
    }

    hasAnchors() {
        if (!this.tabs) {
            return false;
        }
        return this.tabs.length > 0;
    }


    getDataText() {
        return JSON.stringify(this);
    }


    clearData() {
        this.cartList = [];
        this.bundlingList = [];
        this.summeryList = [];
        this.groupBuyList = [];
        this.fcodeList = [];
        this.specialList = [];
        this.tags = new Map();
    }

    setTag(key, value) {
        this.tags.set(key, value);
    }

    getTag(key) {
        return this.tags.get(key)
    }


    static getGoodsSwiperList(list) {
        if (!Array.isArray(list)) {
            return false;
        }
        else {
            let SwiperList = [];
            let items = list;
            for (let i = 0; i < items.length; i++) {
                let item = {};
                item['img'] = items[i];
                item['src'] = '#/';
                SwiperList.push(item);
            }
            return SwiperList;
        }
    }

    getCart(cart_id) {
        for (let i = 0; i < this.cartList.length; i++) {
            if (this.cartList[i].cart_id == cart_id)
                return this.cartList[i];
        }
    }

    getBundling(bl_id) {
        for (let i = 0; i < this.bundlingList.length; i++) {
            if (this.bundlingList[i].bl_id == bl_id) {
                return this.bundlingList[i];
            }
        }
    }

    getSummery(goods_id) {
        for (let i = 0; i < this.summeryList.length; i++) {
            let summery = this.summeryList[i];
            if (summery['goods_id'] == goods_id) {
                return summery;
            }
        }
    }

    getGroupbuy(groupbuy_id) {
        for (let i = 0; i < this.groupBuyList.length; i++) {
            let groupbuy = this.groupBuyList[i];
            if (groupbuy['groupbuy_id'] == groupbuy_id) {
                return groupbuy;
            }
        }
    }

    getLimitTime(xianshi_id) {
        for (let i = 0; i < this.limitTime.length; i++) {
            let LimitTime = this.limitTime[i];
            if (LimitTime['xianshi_id'] == xianshi_id) {
                return LimitTime;
            }
        }
    }

    getFcode(fcode_id) {
        for (let i = 0; i < this.fcodeList.length; i++) {
            let fode = this.fcodeList[i];
            if (fode['fcode_id'] == fcode_id) {
                return fode;
            }
        }
    }

}



export default Proxy



