/**
 * Created by Dell on 2017/5/25.
 */
import Proxy from '../../blocks/util/proxy.js'

class CarProxy extends Proxy {
    constructor() {
        super();
        this.infos = '';
    }

    addData(json) {
        super.addData(json);
        if(this.infos == '') {
            this.infos = json.free_info;
        }
    }

    getGoodsPrice(goods_id, need_bonus) {
        let price = 0;
        let summary = this.getSummery(goods_id);
        if (summary == null) return price;

        if (summary.act_type == 1) {
            let act = this.getGroupbuy(summary.act_id);
            if (act == null) return price;
            price = act.promotion_price;
        } else if (summary.act_type == 2) {
            price = summary.promotion_price;
        } else {
            if (need_bonus) {
                price = summary.bonus_price;
            } else {
                price = summary.goods_price;
            }
        }
        return price;
    }

    unit_price(cart_id, use_bonus) {
        let item = this.getCart(cart_id);

        if (item == null) return 0.00;
        if (item.bl_id > 0) {
            let bl_id = item.bl_id;
            let bl = this.getBundling(bl_id);
            return bl.bl_price;
        } else {
            return this.getGoodsPrice(item.goods_id, use_bonus);
        }
    }

    amountWithOutBonus(cart_id) {
        let item = this.getCart(cart_id);
        return this.unit_price(cart_id, false) * item.goods_num;
    }

    normal(cart_id) {
        let cart = this.getCart(cart_id);
        if (cart.is_bl > 0) {
            return false;
        } else {
            let summary = this.getSummery(cart.goods_id);
            return summary == null || summary.act_type == 0;
        }
    }

    total_amount(selectedCarts, ratios, isLogin) {
        if (selectedCarts.length == 0)
            return 0;
        let normal_amount = 0;
        let special_amount = 0;
        selectedCarts.map(item => {
            if (this.normal(item.cart_id)) {
                let price = this.amountWithOutBonus(item.cart_id);
                normal_amount += price;
            } else {
                let price = this.amountWithOutBonus(item.cart_id);
                special_amount += price;
            }
        })

        if (!isLogin) {
            return normal_amount + special_amount;
        }

        let disc = 0;
        let left = normal_amount * 100;
        let count = ratios.length;

        for (let i = 0; i < count; ++i) {
            let cur = ratios[i];
            let rate = cur.rate;
            let total = cur.total * 100;

            if (left == 0) break;
            if (rate > 100) continue;
            if (total <= 0) continue;

            let max_rate = left * rate / 100.00;
            if (total >= max_rate) {
                disc += max_rate;
                left = 0;
            } else {
                disc += total;
                left -= total * 100 / rate;
            }
        }
        let cur_price = normal_amount * 100 - disc;
        let total_price = cur_price / 100.00 + special_amount;
        return total_price.toFixed(2);
    }
}
export default CarProxy