import SpecialList from '../components/special/special_list.vue'
import GoodsDetail from '../components/goods/goods_detail.vue'
import WebView from '../components/other/webview.vue'
import Main from '../components/main/main.vue'
import SearchPage from '../components/other/search.vue'
import OrderTabs from  '../components/order/list/OrderTabs.vue'
import OrderList from  '../components/order/list/OrderList.vue'
import LogIn from '../components/login/login.vue'
import {base64} from 'vux'
import AddressList from  "../components/address/addressList.vue"
import FcodeList from '../components/fcode/fcode_list.vue'
import ConfirmOrder from '../components/confirm_order/confirm_order.vue'
import addAddress from '../components/address/add_address.vue'
import homeTabs from '../components/main/home/homeTabs.vue'
import homeList from '../components/main/home/homeList.vue'
import shoppingCart from '../components/main/shop-car/shopping_cart.vue'
import Mine from '../components/main/mine/mine.vue'
import Discovery from '../components/main/discovery/discovery.vue'
import BrandList from '../components/main/discovery/brandList.vue'
import functionList from '../components/main/discovery/functionList.vue'
import brandList from '../components/main/discovery/brandList.vue'
import orderPaySn from '../components/order/orderPaySn.vue'
import Comments from '../components/comments/comments.vue'
import Oil from '../components/oil/oil.vue'
import Mobile from '../components/mobile/mobile.vue'

export default [
    {
        path: '/main',
        component: Main,
        children: [
            {
                path: '/',
                redirect: '/index'
            },
            {
                path: 'index',
                component: homeTabs,
                children: [
                    {
                        path: '/',
                        redirect: '/main/index/list/0'
                    },
                    {
                        path: 'list/:special_id',
                        component: homeList,
                    }
                ]
            },
            {
                path: 'shopping_cart',
                component: shoppingCart
            },
            {
                path: 'mine',
                component: Mine
            },
            {
                path: 'discovery',
                component: Discovery,
                children: [
                    {
                        path: 'brand',
                        component: BrandList
                    },
                    {
                        path: 'function',
                        component: functionList
                    }, {
                        path: '/',
                        component: brandList
                    }
                ]
            }
        ]
    },
    {
        path: "/special",
        component: SpecialList
    },
    {
        path: '/goods_detail',
        component: GoodsDetail
    },
    {
        path: '/web',
        component: WebView,
        beforeEnter: (to, from, next) => {
            let url = base64.decode(to.query.url)
            console.log(url);
            window.location.href = url
            next(false);
        }
    },
    {
        path: '/search',
        component: SearchPage
    },
    {
        path: '/order_tabs/:title/:index/:state',
        component: OrderTabs,
        children: [
            {
                path: 'list',
                component: OrderList
            },{
                path:"/",
                component: OrderList
            }
        ]
    },
    {
        path: '/',
        redirect: '/main/index/list/0'
    },
    {
        path: '/login',
        component: LogIn
    },
    {
        path: '/address/list',
        component: AddressList
    },
    {
        path: '/fcodelist',
        component: FcodeList
    },
    {
        path: '/confirm_order',
        component: ConfirmOrder
    },
    {
        path: '/add_address',
        component: addAddress
    },
    {
        path:'/order_pay_sn',
        component:orderPaySn
    },
    {
        path:'/comments',
        component:Comments
    },
    {
        path:'/oil',
        component:Oil
    },
    {
        path:'/mobile',
        component:Mobile
    }
]