/**
 * Created by huanggang on 2017/5/26.
 */
import Vue from 'vue'
import {WechatPlugin, base64} from 'vux'
import DebugUtil from "../../src/components/util/DebugUtil"

Vue.use(WechatPlugin);

class WechatShare
{
    constructor(data, surl)
    {
        DebugUtil.log("share_url", surl)
        let sign_url = encodeURIComponent(surl.split('#')[0]);
        let host = window.location.protocol + '//' + window.location.host;
        let url = host + "/mobile/index.php?act=mshop&op=signurl&client_type=ajax&sign_url=" + sign_url + "&callback=";

        let pThis = this;
        this.getJSONP(url, function (res) {
            if (res.code !== 200) {
                return;
            }
            let sign = res.datas;
            let timestamp = sign.timestamp,
                nonceStr = sign.noncestr,
                signature = sign.signature,
                appid = sign.appid;
            Vue.wechat.config({
                debug: false,
                appId: appid,
                timestamp: timestamp,
                nonceStr: nonceStr,
                signature: signature,
                jsApiList: [
                    'checkJsApi',
                    'onMenuShareTimeline',
                    'onMenuShareAppMessage',
                    'onMenuShareQQ',
                    'onMenuShareWeibo',
                    'onMenuShareQZone',
                    'getNetworkType',
                    'hideOptionMenu',
                    'showOptionMenu',
                    'chooseWXPay'
                ]
            });
            pThis.register(data);
        });
    }

    getJSONP(url, callback) {
        let cn = "callback" + (+new Date()),
            s = document.createElement("script");
        s.type = "text/javascript";
        s.charset = "UTF-8";
        s.src = url + cn;
        let heads = document.head || document.getElementsByTagName('head')[0];
        let sp = heads.appendChild(s);

        setTimeout(function () { //利用计时器 变成异步
            window[cn] = function (data) {
                try {
                    s.onload = s.onreadystatechange = function () {
                        callback && callback(data);
                    }
                }
                catch (e) {
                }
                finally {
                    setTimeout(function () {
                        if (heads && s.parentNode) {
                            sp.parentNode.removeChild(sp);   //最重销毁
                        }
                        window[cn] = null;
                    }, 3000);
                }
            };
        }, 0);
    }

    register(data) {
        Vue.wechat.ready(function () {
            //分享朋友圈  / 2.2 监听“分享到朋友圈”按钮点击、自定义分享内容及分享结果接口
            Vue.wechat.onMenuShareTimeline({
                title: data.title, // 分享标
                desc: data.desc,
                link: data.link,    //cookie读取
                imgUrl: data.img_url,// 分享图标
                trigger: function (res) { 	// 不要尝试在trigger中使用ajax异步请求修改本次分享的内容，因为客户端分享操作是一个同步操作，这时候使用ajax的回包会还没有返回
                },
                success: function (res) {
                },
                cancel: function (res) {
                },
                fail: function (res) {
                }
            });

            //分享给好友
            Vue.wechat.onMenuShareAppMessage({
                title: data.title, // 分享标
                desc: data.desc,
                link: data.link,    //cookie读取
                imgUrl: data.img_url,// 分享图标
                trigger: function (res) {
                },
                success: function (res) {
                }
            });

            Vue.wechat.error(function (res) {
                console.log(res)
                DebugUtil.log("share_result", res);
            });
        })
    }

    unregister() {
    }
}

export default WechatShare;